UNIT MCE;

{$mode objfpc}{$H+}

INTERFACE

USES
  RTL, MCB, MCS;

VAR
  sym: INTEGER;

  PROCEDURE Check(s: INTEGER; msg: ARRAY OF CHAR);
  PROCEDURE CheckTypes(op: INTEGER; VAR x, y: MCB.Item);
  PROCEDURE Qualident(VAR x: MCB.Object_);
  PROCEDURE Expression(VAR x: MCB.Item);

IMPLEMENTATION

PROCEDURE Check(s: INTEGER; msg: ARRAY OF CHAR);
BEGIN
  IF sym = s THEN MCS.Get(sym) ELSE MCB.Mark(msg);
END;

PROCEDURE Simplification(VAR x: MCB.Item);
BEGIN

END;
(*
PROCEDURE CheckTypes(op: INTEGER; VAR x, y: MCB.Item);
VAR
  z    : MCB.Item;
  v    : INT64;
BEGIN

  IF (x.clas = MCB.cConst) AND (y.clas = MCB.cConst) THEN BEGIN

    z      := MCB.NewItem(MCB.cConst,x,y,op);
    z.reg  := -1;
    z.typ  := MCB.intType;
    z.val  := 0;

    IF (x.typ.form = MCB.fInt) AND (y.typ.form = MCB.fInt) THEN BEGIN

      IF x.op = MCS.lx_not THEN x.val := - x.val;
      IF y.op = MCS.lx_not THEN y.val := - y.val;

      IF (op IN [MCS.lx_div,MCS.lx_mod]) AND (y.val = 0) THEN BEGIN
        y.val := 1;
        MCB.Mark('divizion by zerro');
      END
      ELSE IF op = MCS.lx_minus THEN v := INT64(x.val) - INT64(y.val)
      ELSE IF op = MCS.lx_plus  THEN v := INT64(x.val) + INT64(y.val)
      ELSE IF op = MCS.lx_times THEN v := INT64(x.val) * INT64(y.val)
      ELSE IF op = MCS.lx_mod   THEN v := RTL._MOD(INT64(x.val),INT64(y.val))
      ELSE IF op = MCS.lx_div   THEN v := RTL._DIV(INT64(x.val),INT64(y.val))
      ELSE
        MCB.Mark('unknown instruction');

      IF (v > MCB.maxint) OR (v < MCB.minint) THEN
        MCB.Mark('overflow')
      ELSE
        z.val := INTEGER(v);
      z.typ  := MCB.intType;

      IF MCB.errcount = 0 THEN BEGIN
        z.op   := MCS.lx_null;
        z.a    := NIL;
        z.b    := NIL;
      END;

    END ELSE IF (x.typ.form = MCB.fInt) AND (y.typ.form = MCB.fReal) THEN BEGIN
    END ELSE
      MCB.Mark('unknown type');

    x := z;

  END ELSE BEGIN
    x := MCB.NewItem(MCB.cNode,x,y,op);
    x.typ      := y.typ;
    x.typ.size := y.typ.size;
  END;

END;
*)

PROCEDURE CheckTypes(op: INTEGER; VAR x, y: MCB.Item);
VAR
  z    : MCB.Item;
  v    : INT64;
  r    : DOUBLE;
BEGIN

  z     := MCB.NewItem(MCB.cNode,x,y,op);
  z.val := 0;

  IF          (x.typ.form = MCB.fInt)  AND (y.typ.form = MCB.fInt)  THEN BEGIN
    z.typ := MCB.intType;
    IF op = MCS.lx_rdiv THEN z.typ := MCB.realType;
  END ELSE IF ((x.typ.form = MCB.fInt)  AND (y.typ.form = MCB.fReal))
  OR          ((x.typ.form = MCB.fReal) AND (y.typ.form = MCB.fInt))
  OR          ((x.typ.form = MCB.fReal) AND (y.typ.form = MCB.fReal)) THEN
    z.typ := MCB.realType
  ELSE
    MCB.Mark('error type');

  z.typ.size := y.typ.size;

  IF (x.clas = MCB.cConst) AND (y.clas = MCB.cConst) THEN BEGIN
    z.clas := MCB.cConst;
    z.reg  := -1;

    IF x.op = MCS.lx_not THEN BEGIN
      IF x.typ.form = MCB.fReal THEN
        x.val := RTL._RTI(-RTL._ITR(INT64(x.val)))
      ELSE IF x.typ.form = MCB.fInt THEN
        x.val := - x.val;
    END;
    IF y.op = MCS.lx_not THEN BEGIN
      IF y.typ.form = MCB.fReal THEN
        y.val := RTL._RTI(-RTL._ITR(INT64(y.val)))
      ELSE IF y.typ.form = MCB.fInt THEN
        y.val := - y.val;
    END;

    IF (x.typ.form = y.typ.form)  THEN BEGIN

      IF (x.typ.form = MCB.fInt) THEN BEGIN

        IF (op IN [MCS.lx_div,MCS.lx_mod]) AND (y.val = 0) THEN BEGIN
          y.val := 1;
          MCB.Mark('divizion by zerro');
        END
        ELSE IF op = MCS.lx_minus THEN v := INT64(x.val) - INT64(y.val)
        ELSE IF op = MCS.lx_plus  THEN v := INT64(x.val) + INT64(y.val)
        ELSE IF op = MCS.lx_times THEN v := INT64(x.val) * INT64(y.val)
        ELSE IF op = MCS.lx_mod   THEN v := RTL._MOD(INT64(x.val),INT64(y.val))
        ELSE IF op = MCS.lx_div   THEN v := RTL._DIV(INT64(x.val),INT64(y.val))
        ELSE IF op = MCS.lx_rdiv  THEN v := RTL._RTI(INT64(x.val)/INT64(y.val))
        ELSE
          MCB.Mark('unknown instruction');

        IF (v > MCB.maxint) OR (v < MCB.minint) THEN
          MCB.Mark('overflow')
        ELSE
          z.val := INTEGER(v);

      END ELSE IF (x.typ.form = MCB.fReal) THEN BEGIN

        IF (op IN [MCS.lx_rdiv]) AND (RTL._RTI(y.val) = 0) THEN BEGIN
          y.val := RTL._RTI(SINGLE(1.0));
          MCB.Mark('divizion by zerro');
        END
        ELSE IF op = MCS.lx_minus THEN r := RTL._ITR(x.val)-RTL._ITR(y.val)
        ELSE IF op = MCS.lx_plus  THEN r := RTL._ITR(x.val)+RTL._ITR(y.val)
        ELSE IF op = MCS.lx_times THEN r := RTL._ITR(x.val)*RTL._ITR(y.val)
        ELSE IF op = MCS.lx_rdiv  THEN r := RTL._ITR(x.val)/RTL._ITR(y.val)
        ELSE
          MCB.Mark('unknown instruction');

        IF (SINGLE(r) > MCB.maxint) OR (SINGLE(r) < MCB.minint) THEN
          MCB.Mark('overflow')
        ELSE
          z.val := RTL._RTI(SINGLE(r));

      END;

    END ELSE BEGIN

      IF (x.typ.form = MCB.fInt)  AND (y.typ.form = MCB.fReal) THEN BEGIN


          IF (op IN [MCS.lx_rdiv]) AND (RTL._RTI(y.val) = 0) THEN BEGIN
            y.val := 1;
            y.val := RTL._RTI(SINGLE(1.0));
          END
          ELSE IF op = MCS.lx_minus THEN r := x.val - RTL._ITR(y.val)
          ELSE IF op = MCS.lx_plus  THEN r := x.val + RTL._ITR(y.val)
          ELSE IF op = MCS.lx_times THEN r := x.val * RTL._ITR(y.val)
          ELSE IF op = MCS.lx_rdiv  THEN r := x.val / RTL._ITR(y.val)
          ELSE
            MCB.Mark('unknown instruction');

          IF (SINGLE(r) > MCB.maxint) OR (SINGLE(r) < MCB.minint) THEN
            MCB.Mark('overflow')
          ELSE
            z.val := RTL._RTI(SINGLE(r));

      END ELSE IF (x.typ.form = MCB.fReal) AND (y.typ.form = MCB.fInt) THEN BEGIN

        IF (op IN [MCS.lx_rdiv]) AND (y.val = 0) THEN BEGIN
          y.val := RTL._RTI(SINGLE(1.0));
          MCB.Mark('divizion by zerro');
        END
        ELSE IF op = MCS.lx_minus THEN r := RTL._ITR(x.val) - y.val
        ELSE IF op = MCS.lx_plus  THEN r := RTL._ITR(x.val) + y.val
        ELSE IF op = MCS.lx_times THEN r := RTL._ITR(x.val) * y.val
        ELSE IF op = MCS.lx_rdiv  THEN r := RTL._ITR(x.val) / y.val
        ELSE
          MCB.Mark('unknown instruction');

        IF (SINGLE(r) > MCB.maxint) OR (SINGLE(r) < MCB.minint) THEN
          MCB.Mark('overflow')
        ELSE
          z.val := RTL._RTI(SINGLE(r));

      END;

    END;

    IF MCB.errcount = 0 THEN BEGIN
      z.op   := MCS.lx_null;
      z.a    := NIL;
      z.b    := NIL;
    END;
    x := z;

  END;

END;


PROCEDURE Qualident(VAR x: MCB.Object_);
BEGIN
  x := MCB.ThisObj(MCS.id);
  MCS.Get(sym);
  IF x = NIL THEN BEGIN
    x := MCB.dummy;
    MCB.Mark('undef');
  END;
END;

PROCEDURE Factor(VAR x: MCB.Item);
BEGIN

  IF (sym < MCS.lx_char) AND (sym <> lx_minus) OR (sym > MCS.lx_ident) THEN BEGIN
    MCB.Mark('expression expected');
    REPEAT
      MCS.Get(sym)
    UNTIL (sym >= MCS.lx_char) AND (sym <= MCS.lx_ident);
  END;

  IF sym = MCS.lx_ident THEN BEGIN
    MCB.Mark('idents are not processed');
    MCS.Get(sym);
  END ELSE IF sym = MCS.lx_int    THEN BEGIN MCB.MakeConstItem(x,MCB.intType,MCS.i32);  MCS.Get(sym);
  END ELSE IF sym = MCS.lx_real   THEN BEGIN MCB.MakeConstItem(x,MCB.realType,MCS.i32); MCS.Get(sym);
  END ELSE IF sym = MCS.lx_lparen THEN BEGIN MCS.Get(sym); Expression(x); Check(MCS.lx_rparen,'rparen ?');
  END ELSE IF sym = MCS.lx_minus  THEN BEGIN MCS.Get(sym); Factor(x); x.op := MCS.lx_not;
  END ELSE BEGIN
    MCB.Mark('not a factor');
    MCB.MakeConstItem(x,MCB.intType,0);
  END;

END;

PROCEDURE Term(VAR x: MCB.Item);
VAR
  y : MCB.Item;
  op: INTEGER;
BEGIN
  Factor(x);
  WHILE (sym >= MCS.lx_times) AND (sym <= MCS.lx_and) DO BEGIN
    op := sym;
    MCS.Get(sym);
    Factor(y);
    CheckTypes(op,x,y);
  END;
END;

PROCEDURE SimpleExpression(VAR x: MCB.Item);
VAR
  y : MCB.Item;
  op: INTEGER;
BEGIN
  IF sym = MCS.lx_plus THEN BEGIN
    MCS.Get(sym);
    Term(x);
  END ELSE
    Term(x);
  WHILE (sym >= MCS.lx_plus) AND (sym <= MCS.lx_or) DO BEGIN
    op := sym;
    MCS.Get(sym);
    Term(y);
    CheckTypes(op,x,y);
  END;
END;

PROCEDURE Expression(VAR x: MCB.Item);
VAR
  y, z: MCB.Item;
  op  : INTEGER;
BEGIN
  SimpleExpression(x);
  IF (sym >= MCS.lx_eql) AND (sym <= MCS.lx_geq) THEN BEGIN
    op := sym;
    MCS.Get(sym);
    SimpleExpression(y);
    CheckTypes(op,x,y);
    z.typ := MCB.boolType;
  END;
  Simplification(x);
END;

END.

